<template>
  <v-card>
    <!-- Delivery ID -->
    <v-card-title> ID: {{ delivery._id }} </v-card-title>

    <!-- Delivery status -->
    <v-card-title class="primary--text">
      Status: {{ delivery.status.toUpperCase() }}
    </v-card-title>

    <!-- Restaurant name -->
    <v-card-title> From: {{ restaurant.name }} </v-card-title>

    <!-- Restaurant address -->
    <v-card-subtitle>{{
      restaurantAddress.street +
      ', ' +
      restaurantAddress.postalCode +
      ' ' +
      restaurantAddress.city +
      ', ' +
      restaurantAddress.country
    }}</v-card-subtitle>

    <!-- Consumer name -->
    <v-card-title>
      To: {{ consumer.firstName + ' ' + consumer.lastName }}
    </v-card-title>

    <!-- Consumer address -->
    <v-card-subtitle>{{
      deliveryAddress.street +
      ', ' +
      deliveryAddress.postalCode +
      ' ' +
      deliveryAddress.city +
      ', ' +
      deliveryAddress.country
    }}</v-card-subtitle>

    <!-- Income -->
    <v-card-title> Income: ${{ delivery.shipment || 10 }} </v-card-title>

    <!-- Order items -->
    <v-card-title v-if="delivery.status !== 'pending'"> Items: </v-card-title>
    <v-card-text v-if="delivery.status !== 'pending'">
      <!-- Notes -->
      <p v-if="delivery.deliveryNotes && delivery.status !== 'pending'">
        Notes: {{ delivery.deliveryNotes }}
      </p>

      <!-- Dates -->
      <p v-if="['delivering', 'delivered'].includes(delivery.status)">
        Picked up:
        {{ pickedUpDate }}
      </p>
      <p v-if="delivery.status === 'delivered'">
        Delivered:
        {{ deliveredDate }}
      </p>
    </v-card-text>
    <v-card-actions>
      <v-btn
        v-if="delivery.status === 'pending'"
        color="primary"
        @click="accept"
      >
        Accept delivery
      </v-btn>
      <v-btn
        v-if="delivery.status === 'prepared'"
        color="primary"
        @click="pickUp"
      >
        I picked it up!
      </v-btn>
    </v-card-actions>
  </v-card>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  props: {
    delivery: {
      type: Object,
      required: true,
    },
  },
  data: () => {
    return {
      deliveryAddress: {},
      restaurant: {} as any,
      consumer: {} as any,
      restaurantAddress: {},
    }
  },
  computed: {
    pickedUpDate(): string {
      return new Date(this.delivery.timestamps.orderPicked).toUTCString()
    },
    deliveredDate(): string {
      return new Date(this.delivery.timestamps.delivered).toUTCString()
    },
  },
  mounted() {
    this.getDeliveryAddress()
    this.getConsumer()
    this.getRestaurant()
  },
  methods: {
    async getDeliveryAddress() {
      this.deliveryAddress = await this.$axios.$get(
        'http://delivery.localhost:4000/addresses/' +
          this.delivery.deliveryAddress
      )
    },
    async getConsumer() {
      this.consumer = await this.$axios.$get(
        'http://delivery.localhost:4000/consumers/' + this.delivery.consumer
      )
    },
    async getRestaurant() {
      this.restaurant = await this.$axios.$get(
        'http://delivery.localhost:4000/restaurants/' + this.delivery.restaurant
      )

      this.getRestaurantAddress()
    },
    async getRestaurantAddress() {
      this.restaurantAddress = await this.$axios.$get(
        'http://delivery.localhost:4000/addresses/' +
          this.restaurant.addresses[0]
      )
    },
    accept() {
      this.$axios.$put('http://delivery.localhost:4000/orders', {
        _id: this.delivery._id,
        status: 'preparing',
        deliverer: this.$store.state.loggedIn, // ! Current logged in user ID
        timestamps: {
          ...this.delivery.timestamps,
          accepted: Date.now(),
        },
      })

      this.$router.push('/deliveries')
    },
    pickUp() {
      this.$axios.$put('http://delivery.localhost:4000/orders/', {
        _id: this.delivery._id,
        status: 'delivering',
        deliverer: this.$store.state.loggedIn, // ! Current logged in user ID
        timestamps: {
          ...this.delivery.timestamps,
          orderPicked: Date.now(),
        },
      })
    },
  },
})
</script>
